function love.load()
	arrow = 0

	do_pause = false

	debug = false
	debug_collision = false
	editor_mode = false

	textScale = 1
	fps_count = 0
	fps_second = 0
	fps_draw = 0
	fps_total = 0

	UIElement = {}

	love.graphics.setColor(1,1,1)
	love.keyboard.setKeyRepeat(true)
	love.graphics.setDefaultFilter("nearest") -- good pixel

	game = {
		scale = 2,
		width = love.graphics.getWidth(),
		height = love.graphics.getHeight(),
		paused = false
	}

	require "data/scripts"
	Canvas = {
		Darkness = CreateDarkness()
	}
	love.graphics.setCanvas(Canvas.Darkness)
	SetDarkness()
	love.graphics.setCanvas()

	Camera.width = game.width
	Camera.height = game.height

	levelList = {"level1","2","3","ewae","tileset"}
	levelNum = 1
	currLevel = levelList[levelNum]
	LoadedEntities = {}
	LoadedParticles = {}
	LevelLoadTiles()

	main_Player = Player:New(75,50)

	--Kupo:New(100,150)
	--Kupo:New(300,150)
	--Decoration:New(200,89,animation.decoration.candelabra,80)
	--Fairy:New(200,88)
	--CursedBook:New(180,68)

	gravity = 0.2
end

function love.update(dt)
	-- fps counter
	if fps_second >= 1 then
		fps_second = fps_second - 1
		fps_draw = fps_count
		fps_count = 0
		fps_total = fps_total + 1
	end
	fps_second = fps_second + dt
	fps_count = fps_count + 1
	current_dt = dt

	--keypressed
	if Keybind:HasPressed(Keybind.menu.pause) then
    if do_pause then
			do_pause = false
		else
			menuPage = "pauseMenu"
			MenuInit(menuPage)
		end
  end

	--MenuStep
	if menuPage ~= nil then MenuStep(menuPage) end

	--editor
	if editor_mode then
		EditorStep()
	else
		GameStep()
	end
end


function love.wheelmoved(_, y)
	if editor_mode then
		EditorScroll(y)
	end
end

function love.draw()
	if game.width ~= love.graphics.getWidth() or game.height ~= love.graphics.getHeight() then
		game.width = love.graphics.getWidth()
		game.height = love.graphics.getHeight()
		game_resize = true
	else
		game_resize = false
	end

	if editor_mode then
		EditorDraw()
	else
		GameDraw()
	end

	if menuPage ~= nil then MenuDraw(menuPage) end

	love.graphics.print(arrow,10,40)
end
